<?xml version="1.0"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>xyz.ottr.lutra</groupId>
        <artifactId>lutra</artifactId>
        <version>0.6.16-SNAPSHOT</version>
        <relativePath>../pom.xml</relativePath>
    </parent>
    <artifactId>lutra-tabottr</artifactId>

    <name>${project.groupId}:${project.artifactId}</name>
    <description>
        This Lutra submodule implements tabOTTR (https://spec.ottr.xyz/tabOTTR/0.3/). tabOTTR is a mapping language for 
        transforming spreadsheets into template instances.
        
        Lutra is the reference implementation of the OTTR framework. For more information about OTTR, see http://ottr.xyz.
    </description>
    <packaging>jar</packaging>

    <dependencies>

        <dependency>
            <groupId>${project.groupId}</groupId>
            <artifactId>lutra-core</artifactId>
            <!-- for transitive dependencies see module POM -->
        </dependency>

        <dependency>
            <groupId>${project.groupId}</groupId>
            <artifactId>lutra-wottr</artifactId>
            <!-- for transitive dependencies see module POM -->
        </dependency>

        <dependency>
            <groupId>org.apache.poi</groupId>
            <artifactId>poi</artifactId>
            <!-- transitive dependencies:
                - commons-codec
                - commons-collections4
                - slf4j-api
                - commons-math3
                - SparseBitSet<
            -->
        </dependency>

        <dependency>
            <groupId>org.apache.poi</groupId>
            <artifactId>poi-ooxml</artifactId>
            <!-- transitive dependencies:
                - poi (see above)
                - commons-collections4
                - commons-io<
                - commons-compress
                - log4j-api
                - xmlbeans (log4j-api)
                - poi-ooxml-lite (xmlbeans (log4j-api))
                - curvesapi
            -->
        </dependency>

        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-collections4</artifactId>
            <!-- no transitive dependencies -->
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <artifactId>plantuml-generator-maven-plugin</artifactId>
                <groupId>de.elnarion.maven</groupId>
                <executions>
                    <execution>
                        <id>lutra.tabottr</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>tabottr_all.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.tabottr
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.tabottr.model</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>tabottr-model.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.tabottr.model
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                    <execution>
                        <id>lutra.tabottr.parser</id>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                        <phase>generate-test-sources</phase>
                        <configuration>
                            <outputFilename>tabottr-parser.puml</outputFilename>
                            <hideFields>true</hideFields>
                            <hideMethods>true</hideMethods>
                            <scanPackages>
                                <scanPackage>
                                    xyz.ottr.lutra.tabottr.parser
                                </scanPackage>
                            </scanPackages>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
    
</project>
